/* FAUUSP - Curso de Design
   PCS2290 - Fundamentos da computação II
   Trabalho final: Chuva de meteoros
 
   Gabriela Barros da Rocha Martins 
 */
 
//ESTRUTURA DE DADOS DO PROGRAMA

// Vetores das posicoes dos meteoros
float[] posX;
float[] posY;

// Vetores das velocidades dos meteoros
float[] vecX;
float[] vecY;

int meteoros = 20; // numero de meteoros
int falhas = 0; // numero de falhas (particulas que cairam)
int acertos = 0; // numero de particulas apagadas
int falhasPermitidas = 5; // limite de falhas q o jogador pode ter

// Armazena imagens
PImage meteorinho;
PImage terra;
PImage perdeu;
PImage venceu;
PFont fonte;



// Inicializa os meteoros

void updateAll(){
   
  for(int  i = 0; i < meteoros; i++){
    // Atualiza cada meteoro
    updateMeteoro(i);     
  } 
   
}
 
 
// Atualiza um meteoro
// i: meteoro a ser atualizada 
 
void updateMeteoro(int i){
     
  if (posY[i] == -1) return;  
     //atualiza a posicao do meteoro (incere velocidade)
     posX[i] += vecX[i]; 
     posY[i] += vecY[i];     
}



// Funcao que inicializa o direcionamento dos meteoros

void ueba() 
{  
   
   for(int i = 0; i < meteoros; i++){
     direcionaBolinha(i);
   } 
}


// Funcao que tarta da saida inicial dos meteoros (direcionamento)

void direcionaBolinha(int i)
{
  float angle = 0;
  if (posY[i] == -1) return; //se a posY[i] for equivalente a -1 a funcao pára 
  
  // Angulo do meteoro ao entrar na tela
  angle = random(PI/6, PI);
     
  // Define a velocidade do meteoro baseada no angulo
  vecX[i] = random(1,3)*cos(angle);
  vecY[i] = random(1,3)*sin(angle);
  
  // Define posicao inicial dos meteoros  
  posX[i] = random (0,800);
  posY[i] = 0;    
}


// Funcao que trata da acao do mouse

void mousePressed()
{
  int x = mouseX;
  int y = mouseY;
   for(int i = 0; i < meteoros; i++)
   {
     // Se o cursor do mouse acertar o meteoro ele pára
     if (x >= posX[i] - 2 && x < posX[i] + 12 && y >= posY[i]-2 && y <= posY[i] + 12)
     {
       posX[i] = -1; 
       posY[i] = -1;
       // Em caso de acerto sera somado 1 ponto a esta contagem
       acertos++;
     }
   }
}


void setup() {
    
   size(400, 400);
   stroke(255);
   background(0);
   
   terra = loadImage("terra.gif"); // carrega imagem de fundo
   image (terra,0,0,400,400);
   
   fill(255,255,255);
   noStroke();
   smooth();

   meteorinho = loadImage ("meteoro.gif"); // carrega imagem do meteoro
   
   // Cria o espaço dos vetores de posicao
   posX = new float[meteoros];
   posY = new float[meteoros];
   
   // Cria o espaço dos vetores de velocidade
   vecX = new float[meteoros];
   vecY = new float[meteoros];
   ueba();
 } 
 
 // Funcao que carrega a imagem que informa ao jogador que ele venceu o jogo
 void drawGanhou()
 {
   venceu = loadImage("venceu.gif"); 
   background(0,255,0);
   image (venceu, 0,0,400,400);
 }
 
 // Funcao que carrega a imagem que informa ao jogador que ele perdeu o jogo
 void drawPerdeu()
 {
   perdeu = loadImage("perdeu.gif"); 
   background(255,0,0);
   image(perdeu,0,0,400,400);
 }
 
 // Funcao que define se o jogador perdeu ou ganhou
 void draw() {
   if (falhas >= falhasPermitidas)
   {
     drawPerdeu();
     return;
   }
   if (acertos >= meteoros)
   {
     drawGanhou();
     return;
   }

  // Limpa o background com transparencia, criando um efeito blur 
  // e apagando os meteoros que foram acertados pelo mouse
  fill(0,0,0,30);
  stroke(0);
  rect(0, 0, width, height);
  image(terra,0,0,400,400);
  
   //Atualiza os meteoros
   updateAll();
   
   // Carrega a fonte e define o texto informativo do numero de 
   // falhas e acertos
   fonte = loadFont("AgencyFB-Bold-20.vlw");
   textFont(fonte,20);
   fill(255); 
   text(falhas,10,370);
   text("Falhas",10,390);
   text(acertos,380,370);   
   text("Acertos",345,390); 
   stroke (255,0,0);
   
   
   // Inicializa os vetores aleatóriamente
   for(int  i = 0; i < meteoros; i++){
     if (posY[i] == -1) continue;
     
     // Se o meteoro atingir o limite lateral da tela ele é 
     // redirecionado ao inicio
     if (posX[i] > 400 || posX[i] < 0)
     {
        posY[i] = 0;
        posX[i] = 200;
        direcionaBolinha(i);
     }
     
     // Se o meteoro atingir o limite inferior da tela ele é
     // redirecionado ao inicio, mas uma falha é acrescentada à contagem
     if (posY[i] > 400)
     {
        posY[i] = 0;
        posX[i] = 200;
        falhas++;
        direcionaBolinha(i);
     }
     
     // "desenha" o meteoro
     fill(255,0,0);
       image (meteorinho, posX[i], posY[i], 10, 10);  
   }  
   
 }
